#pragma once
#include "LivoxLaser.h"
#include "livox_def.h"
#include "livox_sdk.h"
#include <map>
class CLivoxMid100Laser : public CLivoxLaser
{

public:
	CLivoxMid100Laser(int id, Laser_proto::laser_parameter laser_param);
	~CLivoxMid100Laser();

	//雷达链接设备，为3个线程添加线程执行函数。
	virtual Error_manager connect_laser();
	//雷达断开链接，释放3个线程
	virtual Error_manager disconnect_laser();
	//对外的接口函数，负责接受并处理任务单，
	//input：p_laser_task 雷达任务单，基类的指针，指向子类的实例，（多态）
	//注：这个函数为虚函数，实际的处理任务的代码由子类重载并实现。
	virtual Error_manager execute_task(Task_Base* p_laser_task);
	//检查雷达状态,是否正常运行
	virtual Error_manager check_laser();
	//雷达的启动接口函数， 让雷达进行扫描，一般需要子类重载，不同的雷达开始方式不同。
	virtual Error_manager start_scan();
	//雷达的停止接口函数， 让雷达停止扫描，一般需要子类重载，不同的雷达结束方式不同。
	virtual Error_manager stop_scan();
	//结束任务单，stop之后，要检查线程状态和数据结果，然后才能 end_task
	virtual Error_manager end_task();

	//判断雷达状态是否为待机，如果已经准备好，则可以执行任务。
	//子类重载 is_ready()，里面增加livox sdk后台线程状态的判断。
	virtual bool is_ready();


protected:
	virtual bool IsScanComplete();
	virtual void UpdataHandle();


protected:
	uint8_t		m_handle1;
	uint8_t		m_handle2;
	uint8_t		m_handle3;
};


